/**
 * @file Passphrase.h
 * @brief ptt[Y̊ǗNX
 * @author  Copyright (C) 2002 YUGA <yuga@ops.dti.ne.jp>
 * $Date: $
 * $Revision: $
 */

#pragma once
#include <windows.h>
#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>
#include <time.h>
#include <string>
#include "Config.h"


/////////////////////////////////////////////////////////////////////////////////
//
class PassphraseMgr
{
public:
    PassphraseMgr(PGPContextRef initContext, Config& initConfig);
    virtual ~PassphraseMgr();

    void setDecryptPassphrase(const PGPKeyRef key, char* newDecryptPassphrase);
    char* getDecryptPassphrase(const PGPKeyRef key);
	void clearDecryptPassphrase();
    void setSignPassphrase(const PGPKeyRef key, char* newSignPassphrase);
    char* getSignPassphrase(const PGPKeyRef key);
	void clearSignPassphrase();

protected:
private:
	void clearPassphrase(UINT idEvent);
	void setDecryptPassphraseClearEvent();
	void killDecryptPassphraseClearEvent();
	void setSignPassphraseClearEvent();
	void killSignPassphraseClearEvent();

	static void CALLBACK PassphraseTimeoutHandler(HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime);
	static PassphraseMgr* instance;

    PGPContextRef context;
    PGPKeyID decryptKeyID;
    char* decryptPassphrase;
	UINT_PTR decryptEvent;
    PGPKeyID signKeyID;
    char* signPassphrase;
	UINT_PTR signEvent;

    Config& config;
};


/////////////////////////////////////////////////////////////////////////////////
//
