/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2.h,v $
 * Revision 1.5  2001/01/20 07:40:15  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.4  2000/11/29 12:46:34  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.3  2000/11/23 07:17:57  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.2  2000/11/07 15:57:18  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma once
#pragma warning(disable:4290)


/////////////////////////////////////////////////////////////////////////////////
//
#include <windows.h>
#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <time.h>
#include <string>

#include "B2APIEx.h"
#include "PgpMail.h"
#include "SignatureListener.h"
#include "DecryptListener.h"
#include "PassphraseMgr.h"
#include "Config.h"
#include "stringfr.h"
#include "Hook.h"


/////////////////////////////////////////////////////////////////////////////////
// Exception class
class PGPSdkError : public runtime_error
{
public:
    PGPSdkError(PGPError initError, const std::string& message,
        const std::string& initFile, int initLine);
    virtual std::string getPGPErrorMessage() const throw();
    virtual const std::string& getFile() const throw() { return file; }
    virtual const int getLine() const throw() { return line; }
    virtual std::string getErrorSpecification() const throw();
protected:
private:
    PGPError error;
    std::string file;
    int line;
};

#define PGPSdkError(err, mes)           PGPSdkError(err, mes, __FILE__, __LINE__)
#define PGPCheckSdkError(err, mes)      if (IsPGPError(err)) { throw PGPSdkError(err, mes); } 


/////////////////////////////////////////////////
//
class PGPUserError : public runtime_error
{
public:
    PGPUserError(const std::string& message) : runtime_error(message) {}
protected:
private:
};

#define PGPCheckUserAbort(err, mes)     if (err == kPGPError_UserAbort) { throw PGPUserError(mes); }


/////////////////////////////////////////////////////////////////////////////////
//
class Pgpb2
{
public:
    // Constructer
    Pgpb2(HINSTANCE initInstance) throw();
    virtual ~Pgpb2();

    // 
    virtual void init() throw(PGPSdkError);

    // PGPIy[V
    virtual bool encrypt(HWND hWnd, PgpMail* mail);
    virtual bool signing(HWND hWnd, PgpMail* mail);
    virtual bool encryptSigning(HWND hWnd, PgpMail* mail);
    virtual bool publickey(HWND hWnd);
    virtual bool decodePgpMime(HWND hWnd, PgpMail* mail);
    virtual bool decodeNotPgpMime(HWND hWnd, PgpMail* mail);
    virtual bool clearPassphraseCache();
    virtual bool isPgpmime();

protected:
    // PGP Decode
    virtual bool decodePgpMailPart(BkMail* targetMailPart, HWND hWnd);
    virtual bool decodePgpMailPart2(BkMail* targetMailPart, HWND hWnd);
    virtual bool verifyPgpMimeMail(BkMail* targetMailPart, HWND hWnd);
    virtual bool decryptPgpMimeMail(BkMail* targetMailPart, HWND hWnd);
    virtual bool verifyDetachedSignature(const string& body, const string& sign, SignatureListener& sigListener);
    virtual bool verifyAttachedSignature(const string& pgp, SignatureListener& sigListener);
    virtual bool decrypt(const string& pgp, DecryptListener& decListener, string& out);
    virtual bool explainSigningMessage(const SignatureListener& sigListener, string& out);
    virtual void SigEvent(HWND hwnd,SignatureListener& sigListener, const string& subject);

    // PGP Utility
    virtual int addAddressList(CPointerList& plstAddr, const string& toccbcc);
    virtual void getKeySet(CPointerItem* pItem, PGPKeySetRef& defaultKeySet, PGPKeySetRef& foundUserKeySet) throw(PGPSdkError);
    virtual int getDefaultRecipients(PGPKeySetRef keySet, PGPRecipientSpec*& outSpec) throw(PGPSdkError);
    virtual void getKeyRef(PGPKeySetRef keySet, PGPKeyRef& key, int index = 0) throw (PGPSdkError);
    virtual bool getHashAlgorithm(PGPKeyRef& signingKey, LPSTR lpHash);
    virtual void appendConventionalEncryptionOptionList(HWND hWnd, PGPOptionListRef optionList) throw (PGPUserError, PGPSdkError);
    virtual void appendEncryptionOptionList(PGPKeySetRef keySet, PGPOptionListRef optionList) throw (PGPSdkError);
    virtual std::string getExportKeySetFileName(PGPKeySetRef keySet);
    virtual bool getPassphraseFromSignCache(PGPKeySetRef keySet, PGPKeyRef& key, char*& passpharse);
    virtual void SigTimeToSystemTime(struct tm* ptm, SYSTEMTIME* pst);
    virtual void ConvertSigTimeToString(PGPTime Time, LPSTR sz, INT iLen);
    virtual void SEGetPref64BitsKeyIDDisplay(PGPUInt32 *H64BitsKeyIDDisplay);
    virtual BOOL SEGetKeyIDString(PGPKeyID KeyID, LPSTR sz, UINT u);

private:
    class Pgpb2Correct
    {
    public:
        Pgpb2Correct() { correct = 0; }
        Pgpb2Correct(const Pgpb2Correct& pc) { correct = pc.correct; }
        virtual Pgpb2Correct& operator=(const Pgpb2Correct& pc) { correct = pc.correct; return *this; }
        virtual void init() { correct = 0; }
        virtual void setCorrect(bool state) { correct = (state && correct != 2) ? 1 : 2; }
        virtual bool getCorrect() { return (correct == 1); }
    protected:
    private:
        unsigned int correct;
    };

    Pgpb2Correct correct;

    //HINSTANCE instance;
    PGPContextRef context;
    B2API* b2api;
    B2APIEx* b2apiex;
    PassphraseMgr* cache;
    stringfr* mes;

    // Config & State
    bool pgpmime;
    Config config;
    std::string pgpversion;
};


/////////////////////////////////////////////////////////////////////////////////
//
